"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WNotificationBar = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const w_paper_1 = require("../../layouts/w-paper");
const w_icon_1 = require("../../medias/w-icon");
const buttons_1 = require("../../buttons");
const w_typography_1 = require("../../others/w-typography");
const makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
const classnames_1 = __importDefault(require("classnames"));
const useStyles = (0, makeStyles_1.default)((theme) => ({
    notification: {
        padding: '4px 4px 4px 16px'
    },
    error: {
        backgroundColor: `${theme.palette.error.main} !important`
    },
    warning: {
        backgroundColor: `${theme.palette.warning.main} !important`
    },
    info: {
        backgroundColor: `${theme.palette.info.main} !important`
    },
    success: {
        backgroundColor: `${theme.palette.success.main} !important`
    },
    whiteText: {
        color: `${theme.palette.common.white} !important`
    }
}));
const WNotificationBar = ({ id = '', type = 'info', text = '', onCloseClick }) => {
    const classes = useStyles();
    return ((0, jsx_runtime_1.jsx)(w_paper_1.WPaper, Object.assign({ className: (0, classnames_1.default)(classes.notification, classes[type || 'error']) }, { children: (0, jsx_runtime_1.jsxs)("div", Object.assign({ style: { display: 'flex' } }, { children: [(0, jsx_runtime_1.jsx)(w_typography_1.WTypography, Object.assign({ className: classes.whiteText, style: { flex: 1, alignSelf: 'center' } }, { children: text })), (0, jsx_runtime_1.jsx)(buttons_1.WIconButton, Object.assign({ style: { margin: 0, height: 'min-content' }, id: id + "-close", onClick: () => onCloseClick && onCloseClick(), disableFocusRipple: true, disableRipple: true }, { children: (0, jsx_runtime_1.jsx)(w_icon_1.WIcon, Object.assign({ className: classes.whiteText, style: { fontSize: 15 } }, { children: "close" })) }))] })) })));
};
exports.WNotificationBar = WNotificationBar;
