"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WLoadingButton = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
// @ts-ignore
const classnames_1 = __importDefault(require("classnames"));
const w_button_1 = require("../w-button");
const w_circular_progress_1 = require("../../progress/w-circular-progress");
const makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
const useStyles = (0, makeStyles_1.default)((theme) => ({
    root: {
        display: 'flex',
        alignItems: 'center',
    },
    buttonError: {
        backgroundColor: theme.palette.error.main,
        '&:hover': {
            backgroundColor: theme.palette.error.dark,
        },
    },
    buttonSuccess: {
        backgroundColor: theme.palette.success.main,
        '&:hover': {
            backgroundColor: theme.palette.success.dark,
        },
    },
    circularProgress: {
        color: theme.palette.primary.main,
    },
}));
const WLoadingButton = (props) => {
    const { isLoading } = props, buttonProps = __rest(props, ["isLoading"]);
    const classes = useStyles();
    const buttonClassname = (0, classnames_1.default)({
        [classes.buttonError]: props.status == "error",
        [classes.buttonSuccess]: props.status == "success",
    });
    return ((0, jsx_runtime_1.jsx)(w_button_1.WButton, Object.assign({}, buttonProps, { variant: "contained", color: "primary", className: buttonClassname, disabled: isLoading }, { children: isLoading
            ? (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(w_circular_progress_1.WCircularProgress, { size: 24, className: classes.circularProgress }) })
            : props.children })));
};
exports.WLoadingButton = WLoadingButton;
