import * as React from 'react';
import { AreaProps, BarProps, CartesianGridProps, ComposedChartProps, LegendProps, LineProps, TooltipProps, XAxisProps, YAxisProps } from 'recharts';
export type ChartType = (AreaProps | BarProps | LineProps) & {
    chartType: 'area' | 'bar' | 'line';
};
export interface WChartProps extends Omit<Omit<ComposedChartProps, "width">, "height"> {
    chartData?: ChartType | ChartType[];
    colors?: string[];
    height?: string | number;
    legend?: boolean | LegendProps;
    grid?: boolean | CartesianGridProps;
    tooltip?: boolean | TooltipProps<any, any>;
    width?: string;
    xAxisDataKey: string;
    xAxis?: boolean | XAxisProps;
    yAxis?: boolean | YAxisProps;
    grayColor?: string;
}
export declare class WChart extends React.Component<WChartProps, any> {
    static defaultProps: WChartProps;
    private renderXAxis;
    private renderYAxis;
    private renderLegend;
    private renderTooltip;
    private renderGrid;
    private renderChart;
    private renderCharts;
    private containsBar;
    render(): JSX.Element;
}
