"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WChart = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const colors_1 = require("@mui/material/colors");
const material_1 = require("@mui/material");
const React = __importStar(require("react"));
const recharts_1 = require("recharts");
class WChart extends React.Component {
    constructor() {
        super(...arguments);
        this.renderXAxis = () => {
            if (this.props.xAxis === false) {
                return null;
            }
            let xAxisProps = {
                dataKey: this.props.xAxisDataKey,
                scale: this.containsBar() ? "auto" : "point",
                tickSize: 0,
                minTickGap: 1,
                dy: 15,
                strokeWidth: 0.5,
                tick: { fontSize: 10, fill: this.props.grayColor },
            };
            if (typeof this.props.xAxis !== "boolean") {
                xAxisProps = Object.assign(Object.assign({}, xAxisProps), this.props.xAxis);
            }
            return ((0, jsx_runtime_1.jsx)(recharts_1.XAxis, Object.assign({}, xAxisProps)));
        };
        this.renderYAxis = () => {
            if (this.props.yAxis === false) {
                return null;
            }
            let yAxisProps = {
                tickSize: 0,
                dx: -10,
                strokeWidth: 0.5,
                tick: { fontSize: 10, fill: this.props.grayColor }
            };
            if (typeof this.props.yAxis !== "boolean") {
                yAxisProps = Object.assign(Object.assign({}, yAxisProps), this.props.yAxis);
            }
            return ((0, jsx_runtime_1.jsx)(recharts_1.YAxis, Object.assign({}, yAxisProps)));
        };
        this.renderLegend = () => {
            if (this.props.legend === false) {
                return null;
            }
            let legendProps = {
                align: 'right',
                verticalAlign: 'top',
                wrapperStyle: {
                    // color: this.props.grayColor,
                    opacity: 0.5,
                    fontSize: 11
                }
            };
            if (typeof this.props.legend !== "boolean") {
                legendProps = Object.assign(Object.assign({}, legendProps), this.props.legend);
            }
            return (
            // @ts-ignore
            (0, jsx_runtime_1.jsx)(recharts_1.Legend, Object.assign({}, legendProps)));
        };
        this.renderTooltip = () => {
            if (this.props.tooltip === false) {
                return null;
            }
            let tooltipProps = {
                align: 'right',
                verticalAlign: 'top',
                contentStyle: {
                    borderRadius: 4,
                    border: 'none',
                    boxShadow: '0 8px 15px rgba(125,147,178,.25)',
                    padding: 10
                },
                labelStyle: {
                    fontSize: 14,
                    marginBottom: 5
                },
                wrapperStyle: {
                    opacity: 0.9,
                    fontSize: 12,
                }
            };
            if (typeof this.props.tooltip !== "boolean") {
                tooltipProps = Object.assign(Object.assign({}, tooltipProps), this.props.tooltip);
            }
            return (
            // @ts-ignore
            (0, jsx_runtime_1.jsx)(recharts_1.Tooltip, Object.assign({}, tooltipProps)));
        };
        this.renderGrid = () => {
            if (this.props.grid === false) {
                return null;
            }
            let gridProps = {
                stroke: (0, material_1.alpha)(this.props.grayColor || '', 0.25),
                strokeDasharray: "3 3",
            };
            if (typeof this.props.grid !== "boolean") {
                gridProps = Object.assign(Object.assign({}, gridProps), this.props.grid);
            }
            return (
            // @ts-ignore
            (0, jsx_runtime_1.jsx)(recharts_1.CartesianGrid, Object.assign({}, gridProps)));
        };
        this.renderChart = (chartData, id = 0) => {
            if (!chartData) {
                return null;
            }
            const { chartType } = chartData, chartProps = __rest(chartData, ["chartType"]);
            // @ts-ignore
            const color = this.props.colors[id % this.props.colors.length];
            if (chartType === "area") {
                return ((0, jsx_runtime_1.jsx)(recharts_1.Area, Object.assign({ stroke: color, fill: (0, material_1.alpha)(color, 0.15), type: "monotone", fillOpacity: 1 }, chartProps)));
            }
            else if (chartType === "bar") {
                return ((0, jsx_runtime_1.jsx)(recharts_1.Bar, Object.assign({ fill: color, fillOpacity: 0.75 }, chartProps)));
            }
            else if (chartType === "line") {
                return ((0, jsx_runtime_1.jsx)(recharts_1.Line, Object.assign({ stroke: color }, chartProps)));
            }
            return null;
        };
        this.renderCharts = () => {
            const { chartData } = this.props;
            if (Array.isArray(chartData)) {
                return chartData.map(this.renderChart);
            }
            else {
                return this.renderChart(chartData);
            }
        };
        this.containsBar = () => {
            var _a;
            if (Array.isArray(this.props.chartData)) {
                return this.props.chartData.some(a => a.chartType === "bar");
            }
            else {
                return ((_a = this.props.chartData) === null || _a === void 0 ? void 0 : _a.chartType) === "bar";
            }
        };
    }
    render() {
        const _a = this.props, { height, width } = _a, composedChartProps = __rest(_a, ["height", "width"]);
        return ((0, jsx_runtime_1.jsx)(recharts_1.ResponsiveContainer, Object.assign({ height: height, width: width }, { children: (0, jsx_runtime_1.jsxs)(recharts_1.ComposedChart, Object.assign({}, composedChartProps, { children: [this.renderXAxis(), this.renderYAxis(), this.renderGrid(), this.renderLegend(), this.renderTooltip(), this.renderCharts()] })) })));
    }
}
exports.WChart = WChart;
WChart.defaultProps = {
    colors: [
        colors_1.indigo[600],
        colors_1.red[600],
        colors_1.teal[600],
        colors_1.deepOrange[600],
        colors_1.blue[600],
        colors_1.deepPurple[600],
        colors_1.green[600],
        colors_1.orange[600],
        colors_1.blueGrey[600]
    ],
    grayColor: (0, material_1.darken)('#e8eaf5', 0.25),
    height: 200,
    legend: true,
    tooltip: true,
    width: '100%',
    grid: false,
    xAxisDataKey: '',
    xAxis: true,
    yAxis: true,
    chartData: undefined,
};
