"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WMessageDialog = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const w_basic_dialog_1 = require("../w-basic-dialog");
const WMessageDialog = (props) => {
    const { id = "", open = false, title = '', text = '', buttons = "Ok" } = props;
    const getButtons = () => {
        const result = [];
        if (buttons === "YesNo" || buttons === "YesNoCancel") {
            result.push({
                text: 'Yes',
                onClick: (event) => { props.onButtonClick && props.onButtonClick(event, 'Yes'); }
            });
            result.push({
                text: 'No',
                onClick: (event) => { props.onButtonClick && props.onButtonClick(event, 'No'); }
            });
        }
        if (buttons === "YesNoCancel") {
            result.push({
                text: 'Cancel',
                onClick: (event) => { props.onButtonClick && props.onButtonClick(event, 'Cancel'); }
            });
        }
        if (buttons === "Ok") {
            result.push({
                text: 'Ok',
                onClick: (event) => { props.onButtonClick && props.onButtonClick(event, 'Ok'); }
            });
        }
        return result;
    };
    return ((0, jsx_runtime_1.jsx)(w_basic_dialog_1.WBasicDialog, { id: id, open: open, title: title, children: text, actions: getButtons(), fullWidth: true }));
};
exports.WMessageDialog = WMessageDialog;
