"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WTextField = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
//#region imports
const material_1 = require("@mui/material");
const w_icon_button_1 = require("../../buttons/w-icon-button");
const w_icon_1 = require("../../medias/w-icon");
const react_1 = require("react");
const WTextField = (props) => {
    const { leftButtons = [], rightButtons = [], type, InputProps, inputProps } = props, restProps = __rest(props, ["leftButtons", "rightButtons", "type", "InputProps", "inputProps"]);
    const textFieldRef = (0, react_1.useRef)();
    const [showPassword, setShowPassword] = (0, react_1.useState)(false);
    const innerType = (0, react_1.useMemo)(() => type === "password" && showPassword ? "text" : type, [type, showPassword]);
    const renderButtons = (0, react_1.useCallback)((buttons) => {
        return buttons.map((btn, index) => {
            return ((0, jsx_runtime_1.jsx)("span", { children: (0, jsx_runtime_1.jsx)(w_icon_button_1.WIconButton, Object.assign({ id: btn.id, onClick: () => btn.onClick && btn.onClick.bind(this)(null, null), onMouseDown: () => event === null || event === void 0 ? void 0 : event.preventDefault() }, { children: btn.icon })) }, index));
        });
    }, []);
    const renderAdornments = (0, react_1.useCallback)(() => {
        const result = {};
        if (type == "password") {
            let action = {
                icon: (0, jsx_runtime_1.jsx)(w_icon_1.WIcon, { children: showPassword ? "visibility_off" : "visibility" }),
                onClick: function (e, value) {
                    // @ts-ignore
                    setShowPassword(prev => !prev);
                }
            };
            rightButtons.push(action);
        }
        if (leftButtons.length > 0) {
            result.startAdornment = ((0, jsx_runtime_1.jsx)(material_1.InputAdornment, Object.assign({ position: "start" }, { children: renderButtons(leftButtons) })));
        }
        if (rightButtons.length > 0) {
            result.endAdornment = ((0, jsx_runtime_1.jsx)(material_1.InputAdornment, Object.assign({ position: "end" }, { children: renderButtons(rightButtons) })));
        }
        return result;
    }, [type, showPassword, leftButtons, rightButtons]);
    let innerInputProps = (0, react_1.useMemo)(() => (Object.assign(Object.assign({}, InputProps), renderAdornments())), [InputProps, renderAdornments]);
    return ((0, jsx_runtime_1.jsx)(material_1.TextField, Object.assign({}, props, { type: innerType, InputProps: innerInputProps, inputProps: Object.assign(Object.assign({}, inputProps), { ref: textFieldRef }) })));
};
exports.WTextField = WTextField;
