"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WIcon = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const material_1 = require("@mui/material");
const makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
const MaterialIcons = __importStar(require("@mui/icons-material"));
const lodash_1 = __importDefault(require("lodash"));
const sizeMap = {
    small: { size: 'sm', style: { verticalAlign: 'top', padding: '1.6px 2.68px', fontSize: 17 } },
    default: { size: 'lg', style: { verticalAlign: 'top', padding: '4.5px 3.68px', fontSize: 21 } },
    large: { size: '2x', style: { verticalAlign: 'top', padding: '1.8px 4.68px', fontSize: 31 } },
};
const useStyles = (0, makeStyles_1.default)((theme) => ({
    root: {
        textTransform: 'none',
        boxShadow: theme.designDetails.defaultElevation ? '' : 'none',
    }
}));
const WIcon = (props) => {
    const classes = useStyles();
    const theme = (0, material_1.useTheme)();
    const { iconSize = 'default', iconSource = 'material-icons' } = props, iconProps = __rest(props, ["iconSize", "iconSource"]);
    if (iconSource == 'material-icons') {
        const iconName = lodash_1.default.startCase(lodash_1.default.camelCase(props.icon || props.children)).replace(/ /g, '');
        // @ts-ignore
        const IconComponent = MaterialIcons[iconName];
        if (IconComponent) {
            return (0, jsx_runtime_1.jsx)(IconComponent, Object.assign({ classes: classes }, iconProps, { style: Object.assign({ fontSize: iconSize }, iconProps.style) }));
        }
        else {
            return null;
        }
        // return <Icon classes={classes} {...iconProps} style={{ fontSize: iconSize, ...iconProps.style }}>{props.icon || props.children}</Icon>
    }
    else {
        let className = props.icon || props.children;
        className += " fa-" + sizeMap[iconSize].size;
        const style = Object.assign(Object.assign({}, sizeMap[iconSize].style), props.style);
        if (props.color && props.color != "inherit") {
            // @ts-ignore
            style.color = props.theme.palette[props.color].main;
        }
        return (0, jsx_runtime_1.jsx)("i", { className: className, style: style });
    }
};
exports.WIcon = WIcon;
