"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const react_router_1 = require("react-router");
const react_router_dom_1 = require("react-router-dom");
const store_1 = require("../../../store");
const ProtectedRoute = ({ children }) => {
    let location = (0, react_router_1.useLocation)();
    const { isLoggedIn } = (0, store_1.useUserContext)();
    const { authRequired } = (0, store_1.useConfiguration)();
    if (authRequired && !isLoggedIn) {
        return (0, jsx_runtime_1.jsx)(react_router_dom_1.Navigate, { to: "/login", state: { from: location }, replace: true });
    }
    return children;
};
const LoginRoute = ({ children }) => {
    let location = (0, react_router_1.useLocation)();
    const { isLoggedIn } = (0, store_1.useUserContext)();
    const { authRequired } = (0, store_1.useConfiguration)();
    if ((!authRequired || isLoggedIn)) {
        return (0, jsx_runtime_1.jsx)(react_router_dom_1.Navigate, { to: "/main", state: { from: location }, replace: true });
    }
    return children;
};
const WDefaultContainer = () => {
    const appContext = (0, store_1.useAppContext)();
    const userContext = (0, store_1.useUserContext)();
    const configuration = (0, store_1.useConfiguration)();
    const setValue = (0, react_1.useCallback)((key, value) => appContext.setValue(key, value), []);
    return ((0, jsx_runtime_1.jsxs)(react_router_dom_1.Routes, { children: [(0, jsx_runtime_1.jsx)(react_router_dom_1.Route, { path: "/", element: (0, jsx_runtime_1.jsx)(react_router_dom_1.Navigate, { to: "/main" }) }), (0, jsx_runtime_1.jsx)(react_router_dom_1.Route, { path: "/login", element: (0, jsx_runtime_1.jsx)(LoginRoute, { children: (0, jsx_runtime_1.jsx)(configuration.components.LoginPage, { appContext: appContext, userContext: userContext, setValue: setValue }) }) }), (0, jsx_runtime_1.jsx)(react_router_dom_1.Route, { path: "/main/*", element: (0, jsx_runtime_1.jsx)(ProtectedRoute, { children: (0, jsx_runtime_1.jsx)(configuration.components.MainPage, { style: { height: '100%' } }) }) })] }));
};
exports.default = WDefaultContainer;
