"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
//#region imports 
const __1 = require("../../../");
// @ts-ignore
const login_bg_jpg_1 = __importDefault(require("../../../assets/login-bg.jpg"));
// @ts-ignore
const login_logo_png_1 = __importDefault(require("../../../assets/login-logo.png"));
const react_1 = require("react");
const makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
const store_1 = require("../../../store");
//#endregion
const useStyles = (0, makeStyles_1.default)((theme) => ({
    vSpace: {
        marginTop: theme.spacing(2),
    }
}));
const WLoginPage = () => {
    const classes = useStyles();
    const configuration = (0, store_1.useConfiguration)();
    const authService = configuration.useAuthService();
    const [isLoading, setIsLoading] = (0, react_1.useState)(false);
    const [showNotification, setShowNotification] = (0, react_1.useState)(false);
    const [notificationText, setNotificationText] = (0, react_1.useState)('');
    const [username, setUsername] = (0, react_1.useState)('');
    const [password, setPassword] = (0, react_1.useState)('');
    const btnLoginClick = (0, react_1.useCallback)(() => __awaiter(void 0, void 0, void 0, function* () {
        setIsLoading(true);
        try {
            const response = yield authService.login(username, password);
        }
        catch (message) {
            setNotificationText(message);
            setShowNotification(true);
        }
        setIsLoading(false);
    }), [username, password, authService.login]);
    const keyPressed = (0, react_1.useCallback)((e) => {
        if (e.key == 'Enter') {
            btnLoginClick();
        }
    }, [btnLoginClick]);
    return ((0, jsx_runtime_1.jsx)("div", Object.assign({ style: { height: '100vh', width: '100%', backgroundImage: `url(${login_bg_jpg_1.default})` } }, { children: (0, jsx_runtime_1.jsx)("div", Object.assign({ style: { paddingTop: '5%' } }, { children: (0, jsx_runtime_1.jsxs)(__1.WGrid, Object.assign({ container: true, justifyContent: "center", style: { paddingLeft: 10, paddingRight: 10 } }, { children: [(0, jsx_runtime_1.jsx)(__1.WGrid, Object.assign({ item: true, xs: 12, sm: 6, md: 4, lg: 3 }, { children: (0, jsx_runtime_1.jsx)(__1.WCard, { children: (0, jsx_runtime_1.jsxs)(__1.WCardContent, { children: [(0, jsx_runtime_1.jsx)(__1.WTypography, Object.assign({ variant: "h4", gutterBottom: true, align: "center", style: { marginTop: 75 }, color: "primary" }, { children: (0, jsx_runtime_1.jsx)("img", { src: login_logo_png_1.default }) })), showNotification &&
                                        (0, jsx_runtime_1.jsx)(__1.WNotificationBar, { id: "login-page-notification-bar", text: notificationText, type: "error", onCloseClick: () => setShowNotification(false) }), (0, jsx_runtime_1.jsx)(__1.WTextField, { id: "username", label: "Kullan\u0131c\u0131 Ad\u0131", fullWidth: true, margin: "normal", className: classes.vSpace, value: username, onChange: e => setUsername(e.target.value), onKeyPress: keyPressed }), (0, jsx_runtime_1.jsx)(__1.WTextField, { id: "password", label: "\u015Eifre", fullWidth: true, margin: "normal", type: "password", autoComplete: "current-password", className: classes.vSpace, value: password, onChange: e => setPassword(e.target.value), onKeyPress: keyPressed }), (0, jsx_runtime_1.jsx)("div", { className: classes.vSpace }), (0, jsx_runtime_1.jsx)(__1.WLoadingButton, Object.assign({ id: "btn-login", variant: "contained", size: "large", fullWidth: true, color: "primary", className: classes.vSpace, style: { marginTop: 50, marginBottom: 20 }, isLoading: isLoading, disableFocusRipple: true, onClick: btnLoginClick }, { children: "Giri\u015F" }))] }) }) })), (0, jsx_runtime_1.jsx)(__1.WGrid, Object.assign({ item: true, xs: 12, style: { textAlign: 'center' } }, { children: (0, jsx_runtime_1.jsx)(__1.WTypography, Object.assign({ style: { color: '#ddd' } }, { children: "@2018 DigiTurk" })) }))] })) })) })));
};
exports.default = WLoginPage;
