"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const __1 = require("../../../");
const fuse_js_1 = __importDefault(require("fuse.js"));
// var Fuse = require('fuse.js');
exports.default = {
    search(term, appContext) {
        return new Promise((resolve, reject) => {
            const list = [];
            __1.MenuTreeUtil.menuTreeForEach(appContext.menuTree, (item) => {
                if (item.subNodes && item.subNodes.length > 0) {
                    return false;
                }
                list.push(item);
                return false;
            });
            // @ts-ignore
            const fuse = new fuse_js_1.default(list, {
                shouldSort: true,
                threshold: 0.3,
                location: 0,
                distance: 100,
                // maxPatternLength: 32,
                minMatchCharLength: 1,
                keys: [
                    "text",
                ]
            });
            const result = fuse.search(term).map(i => i.item);
            resolve(result);
        });
    },
    renderSearchItem(item, appContext) {
        return ((0, jsx_runtime_1.jsxs)(__1.WListItem, Object.assign({ id: "search-item-" + item.id, dense: true }, { children: [(0, jsx_runtime_1.jsx)(__1.WListItemIcon, { children: typeof item.icon == "string" ? ((0, jsx_runtime_1.jsx)(__1.WIcon, { children: item.icon })) : ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: item.icon })) }), (0, jsx_runtime_1.jsx)(__1.WListItemText, { children: item.text })] }), "key-search-item-" + item.id));
    },
    onItemSelected(item, appContext) {
        appContext.openScreen(item);
    }
};
