"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStorage = void 0;
const react_1 = require("react");
const useStorage = (type = 'session') => {
    const storage = (0, react_1.useMemo)(() => type === 'local' ? localStorage : sessionStorage, [type]);
    const set = (0, react_1.useCallback)((key, value) => __awaiter(void 0, void 0, void 0, function* () {
        storage.setItem(key, JSON.stringify({
            data: value
        }));
    }), []);
    const get = (0, react_1.useCallback)((key, defaultValue) => {
        const value = storage.getItem(key);
        if (value) {
            const item = JSON.parse(value);
            return item.data;
        }
        else {
            return defaultValue;
        }
    }, []);
    const remove = (0, react_1.useCallback)((key) => __awaiter(void 0, void 0, void 0, function* () {
        storage.removeItem(key);
    }), []);
    const result = (0, react_1.useMemo)(() => ({
        get,
        set,
        remove
    }), [get, set, remove]);
    return result;
};
exports.useStorage = useStorage;
