import React, { FC } from "react";
import { AxiosResponse } from 'axios';
interface Result<T> {
    data: T;
    hasError: boolean;
    error: any;
    errorMessage: string;
    details?: any;
    status?: AxiosResponse['status'];
}
interface ApiContextValue {
    authenticated: boolean;
    get: <T = any>(resource: string) => Promise<Result<T>>;
    post: <T = any>(resource: string, data?: any) => Promise<Result<T>>;
    put: <T = any>(resource: string, data?: any) => Promise<Result<T>>;
    delete: <T = any>(resource: string) => Promise<Result<T>>;
}
export interface ApiContextProviderProps {
    children: React.ReactNode;
}
export declare const ApiContextProvider: FC<ApiContextProviderProps>;
export declare const useApi: () => ApiContextValue;
export {};
