"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.saveState = exports.loadState = void 0;
const loadState = () => {
    try {
        const serializedState = localStorage.getItem('state');
        if (serializedState === null) {
            return undefined;
        }
        return JSON.parse(serializedState);
    }
    catch (err) {
        return undefined;
    }
};
exports.loadState = loadState;
const saveState = (state) => {
    try {
        const serializedState = JSON.stringify(state);
        localStorage.setItem('state', serializedState);
    }
    catch (err) {
        // Ignore write errors.
    }
};
exports.saveState = saveState;
