import React, { FC } from "react";
import { IConfiguration } from "..";
export interface UserContext {
    readonly displayName?: string;
    readonly isLoggedIn?: boolean;
    readonly token?: string;
    readonly username?: string;
    readonly data?: any;
}
interface UserContextValue extends UserContext {
    login: (values: UserContext) => void;
    logout: () => void;
}
interface UserContextProviderProps {
    children: React.ReactNode;
    useLocalStorage: IConfiguration["useLocalStorage"];
    projectName: IConfiguration["projectName"];
}
export declare const UserContextProvider: FC<UserContextProviderProps>;
export declare const useUserContext: () => UserContextValue;
export {};
